package iot.system.iotserver.config;

public class CmdLineArgs {
    static private String[] args;
    static private String kafkaServers;
    static private String consumerGroup;
    static private Integer serverID;

    static public void storeArgs(String[] args){
        CmdLineArgs.args = args;
        CmdLineArgs.parseArgs(args);
    }

    static public String[] getArgs(){
        return CmdLineArgs.args;
    }

    static private void parseArgs(String[] args){
        int argPos = 0;
        String arg;
        while(argPos<args.length){
            arg = args[argPos];
            if(("-s").equals(arg)){
                CmdLineArgs.kafkaServers = args[argPos + 1];
                argPos = argPos + 2;
                System.out.println("Kafka brokers: "+CmdLineArgs.kafkaServers);
                continue;
            }
            if(("-g").equals(arg)){
                CmdLineArgs.consumerGroup = args[argPos + 1];
                argPos = argPos + 2;
                System.out.println("Group: "+CmdLineArgs.consumerGroup);
                continue;
            }
            if(("-id").equals(arg)){
                CmdLineArgs.serverID = Math.abs(Integer.parseInt(args[argPos + 1]));
                if(CmdLineArgs.serverID == 0){
                    throw new RuntimeException("Server ID 0 is NOT ALLOWED!!!");
                }
                argPos = argPos + 2;
                System.out.println("Server ID: "+CmdLineArgs.serverID);
                continue;
            }
            argPos = argPos + 1;
        }
    }

    public static String getKafkaServers() {
        return kafkaServers;
    }

    public static String getConsumerGroup() {
        return consumerGroup;
    }

    public static Integer getServerID() {
        return serverID;
    }
}
