/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package iot.system.iotserver.message;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import iot.system.iotserver.json.InstantDeserializer;
import iot.system.iotserver.json.InstantSerializer;
import iot.system.iotserver.message.node.BoardConfigMessage;
import iot.system.iotserver.message.node.HeartbeatMessage;
import iot.system.iotserver.message.node.InterfaceConfigMessage;
import iot.system.iotserver.message.node.InterfaceStateMessage;
import iot.system.iotserver.message.server.*;

import java.time.Instant;

/**
 *
 * @author janzubr
 */
@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME)
@JsonSubTypes({
    //Node-Server-Node messages
    @JsonSubTypes.Type(value = InterfaceStateMessage.class, name = "InterfaceStateMessage"),
    @JsonSubTypes.Type(value = InterfaceConfigMessage.class, name = "InterfaceConfigMessage"),
    @JsonSubTypes.Type(value = BoardConfigMessage.class, name = "BoardConfigMessage"),
    @JsonSubTypes.Type(value = HeartbeatMessage.class, name = "HeartbeatMessage"),

    //Server-Server messages
    @JsonSubTypes.Type(value = ConnectionMessage.class, name = "ConnectionMessage"),
    @JsonSubTypes.Type(value = ConnectionAcceptedMessage.class, name = "ConnectionAcceptedMessage"),
    @JsonSubTypes.Type(value = ConnectionDeniedMessage.class, name = "ConnectionDeniedMessage"),
    @JsonSubTypes.Type(value = TopologyUpdateMessage.class, name = "TopologyUpdateMessage"),
    @JsonSubTypes.Type(value = ServerHeartbeatMessage.class, name = "ServerHeartbeatMessage"),
    @JsonSubTypes.Type(value = LeaderElectionMessage.class, name = "LeaderElectionMessage"),
    @JsonSubTypes.Type(value = LeaderElectedMessage.class, name = "LeaderElectedMessage")
})
public abstract class ExchangeMessage {
    @JsonDeserialize(using = InstantDeserializer.class)
    @JsonSerialize(using = InstantSerializer.class)
    protected Instant timestamp;
    protected String nodeLogin;

    public ExchangeMessage() {

    }

    public Instant getTimestamp() {
        return timestamp;
    }

    public String getNodeLogin() {
        return nodeLogin;
    }

    public void setTimestamp(Instant timestamp) {
        this.timestamp = timestamp;
    }

    public void setNodeLogin(String nodeLogin) {
        this.nodeLogin = nodeLogin;
    }

    @Override
    public String toString() {
        return "ExchangeMessage{" +
                "timestamp=" + timestamp +
                ", nodeLogin='" + nodeLogin + '\'' +
                '}';
    }
}
