package iot.system.iotserver.model;

import iot.system.iotserver.enums.BoardStatus;

import javax.persistence.*;
import java.io.Serializable;
import java.time.Instant;
import java.util.List;

@Entity
public class Board implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long ID;

    @Column(unique = true, length = 100)
    private String login;

    private String pass;
    private String name;
    private Integer commInterval;

    @Column(columnDefinition="DATETIME(3)")
    private Instant lastActive;

    private Integer deadMultiplier;

    @OneToMany(mappedBy = "board")
    private List<Interface> interfaces;

    @Enumerated(EnumType.STRING)
    private BoardStatus status;

    public Long getID() {
        return ID;
    }

    public void setID(Long ID) {
        this.ID = ID;
    }

    public String getLogin() {
        return login;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public String getPass() {
        return pass;
    }

    public void setPass(String pass) {
        this.pass = pass;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getCommInterval() {
        return commInterval;
    }

    public void setCommInterval(Integer commInterval) {
        this.commInterval = commInterval;
    }

    public List<Interface> getInterfaces() {
        return interfaces;
    }

    public void setInterfaces(List<Interface> interfaces) {
        this.interfaces = interfaces;
    }

    public Instant getLastActive() {
        return lastActive;
    }

    public void setLastActive(Instant lastActive) {
        this.lastActive = lastActive;
    }

    public Integer getDeadMultiplier() {
        return deadMultiplier;
    }

    public void setDeadMultiplier(Integer deadMultiplier) {
        this.deadMultiplier = deadMultiplier;
    }

    public BoardStatus getStatus() {
        return status;
    }

    public void setStatus(BoardStatus status) {
        this.status = status;
    }
}
