package iot.system.iotserver.model;;

import javax.persistence.*;
import java.io.Serializable;
import java.util.List;

@Entity
@Table(uniqueConstraints={
        @UniqueConstraint(columnNames = {"board_id", "uid"})
})
public class Interface implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long ID;

    @ManyToOne(fetch = FetchType.EAGER, optional = false)
    private Board board;

    @OneToMany(mappedBy = "iface")
    private List<InterfaceConfig> config;

    @Transient
    private List<ModuleVar> attachedVars;

    private String uid;

    public Long getID() {
        return ID;
    }

    public void setID(Long ID) {
        this.ID = ID;
    }

    public Board getBoard() {
        return board;
    }

    public void setBoard(Board board) {
        this.board = board;
    }

    public List<InterfaceConfig> getConfig() {
        return config;
    }

    public void setConfig(List<InterfaceConfig> config) {
        this.config = config;
    }

    public List<ModuleVar> getAttachedVars() {
        return attachedVars;
    }

    public void setAttachedVars(List<ModuleVar> attachedVars) {
        this.attachedVars = attachedVars;
    }

    public String getUid() {
        return uid;
    }

    public void setUid(String uid) {
        this.uid = uid;
    }
}
