package iot.system.iotserver.support;

import org.springframework.boot.logging.LogLevel;

import java.time.Instant;
import java.util.ArrayList;
import java.util.List;

public class CustomLogger {
    private static CustomLogger instance;

    private List<String> log;

    private CustomLogger(){
        this.log = new ArrayList<>();
    }

    public static CustomLogger getInstance(){
        if(CustomLogger.instance==null){
            CustomLogger.instance = new CustomLogger();
        }
        return CustomLogger.instance;
    }

    public synchronized void addToLog(String text){
        this.addToLog(text,LogLevel.INFO);
    }

    public synchronized void addToLog(String text, LogLevel level){
        String logLine = "[ "+ Instant.now().toString()+" ] || "+level+" || "+text;
        this.log.add(logLine);
        System.out.println(logLine);
    }

    public List<String> getLog() {
        return log;
    }

    public static void log(String text){
        CustomLogger.getInstance().addToLog(text);
    }

    public static void log(String text, LogLevel level){
        CustomLogger.getInstance().addToLog(text, level);
    }
}
