/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package board.gpio;

import board.Board;
import board.gpio.dto.PinDTO;

/**
 *
 * @author janzubr
 */
public class Pin {
    private final int number;
    private final PinDirection direction;
    private PinState state;
    private boolean isWritten;

    public Pin(int number, PinDirection dir) {
        this.number = number;
        this.direction = dir;
        this.state = PinState.LOW;
        this.isWritten = false;
    }
    
    public Pin(PinDTO dto){
        this.number = dto.getNumber();
        this.direction = dto.getDirection();
        this.state = dto.getState();
        this.isWritten = false;
    }

    public int getNumber() {
        return number;
    }

    public synchronized PinState getState() {
        return state;
    }

    public synchronized void setState(PinState state) {
        PinState prevState = this.state;
        this.state = state;
        this.isWritten = false;
        //if((this.direction.isOut())&&(this.state!=prevState)){
        /*
        if(this.state!=prevState){
            Board.getInstance().notifyPinUpdate(this);
        }
        */
    }
    
    public synchronized boolean isWritten(){
        return this.isWritten;
    }
    
    public synchronized void setWrittenFlag(){
        this.isWritten=true;
    }

    public PinDirection getDirection() {
        return direction;
    }
    
    public synchronized void setLow(){
        this.setState(PinState.LOW);
    }
    
    public synchronized void setHigh(){
        this.setState(PinState.HIGH);
    }
    
    public synchronized PinState toggle(){
        if(this.state.isHigh()){
            this.setLow();
        }
        else{
            this.setHigh();
        }
        return this.state;
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 79 * hash + this.number;
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Pin other = (Pin) obj;
        return this.number == other.number;
    }

    @Override
    public String toString() {
        return "Pin{" + "number=" + number + ", state=" + state + ", direction=" + direction + '}';
    }  
}
