package board.io.uart;

import board.io.Interface;
import board.io.InterfaceDirection;
import board.io.InterfaceType;
import com.fazecast.jSerialComm.SerialPort;
import com.fazecast.jSerialComm.SerialPortDataListener;
import com.fazecast.jSerialComm.SerialPortEvent;
import exceptions.WrongInterfaceTypeException;
import exchange.Exchange;
import exchange.ExchangeMessageFactory;

public class UartListener implements SerialPortDataListener {
    protected Interface intf;

    public UartListener(Interface intf) {
        this.intf = intf;

        if(intf.getDescriptor().getType() != InterfaceType.UART){
            throw new RuntimeException(new WrongInterfaceTypeException("Expected interface of UART type. Got: "+intf.getDescriptor().getType()));
        }
    }

    @Override
    public int getListeningEvents() {
        return SerialPort.LISTENING_EVENT_DATA_RECEIVED;
    }

    @Override
    public void serialEvent(SerialPortEvent event) {
        this.intf.setDataIn(event.getReceivedData());
        Exchange.getInstance().pushMessage(ExchangeMessageFactory.createInterfaceStateMessage(this.intf, InterfaceDirection.IN));
    }
}
