/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package board.utils;

import board.BoardType;
import board.gpio.PinDirection;
import board.gpio.PinState;
import java.io.IOException;

import board.io.Interface;
import board.io.InterfaceDirection;
import board.io.InterfaceType;
import config.Config;

/**
 *
 * @author janzubr
 */
public abstract class BoardUtils {
    private static BoardUtils utils = null;
    
    protected BoardUtils(){
        
    }

    static public BoardUtils getBoardUtils(){
        if(BoardUtils.utils != null){
            return BoardUtils.utils;
        }
        
        if(Config.getBoardType()==BoardType.ALLWINNER){
            BoardUtils.utils = new AllwinnerUtils();
        }
        
        return BoardUtils.utils;
    }

    public boolean openInterface(Interface intf){
        if(intf.getDescriptor().getType() == InterfaceType.PIN){
            return openPin(intf);
        }
        else if(intf.getDescriptor().getType() == InterfaceType.UART){
            return openUart(intf);
        }
        return false;
    }

    abstract protected boolean openPin(Interface intf);
    abstract protected boolean openUart(Interface intf);

    public boolean writeInterface(Interface intf){
        if(intf.getDescriptor().getType() == InterfaceType.PIN){
            return writePin(intf);
        }
        else if(intf.getDescriptor().getType() == InterfaceType.UART){
            return writeUart(intf);
        }
        return false;
    }

    abstract protected boolean writePin(Interface intf);
    abstract protected boolean writeUart(Interface intf);

    public boolean readInterface(Interface intf){
        if(intf.getDescriptor().getType() == InterfaceType.PIN){
            return readPin(intf);
        }
        else if(intf.getDescriptor().getType() == InterfaceType.UART){
            return readUart(intf);
        }
        return false;
    }

    abstract protected boolean readPin(Interface intf);
    abstract protected boolean readUart(Interface intf);

    public boolean closeInterface(Interface intf){
        if(intf.getDescriptor().getType() == InterfaceType.PIN){
            return closePin(intf);
        }
        else if(intf.getDescriptor().getType() == InterfaceType.UART){
            return closeUart(intf);
        }
        return false;
    }

    abstract protected boolean closePin(Interface intf);
    abstract protected boolean closeUart(Interface intf);

}
