/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exchange.auth;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author janzubr
 */
public class AuthHandler {
    private final String login;
    private final String pass;

    public AuthHandler(String login, String pass) {
        this.login = login;
        this.pass = pass;
    }
    
    public String getAuthString(String endpoint){
        return this.login + ":" + AuthHandler.getNonce() + ":" + this.getDigest(endpoint);
    }
    
    private static String getNonce(){
        return new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
    }
    
    private String getDigest(String endpoint){
        String nonce = AuthHandler.getNonce();
        String digestBase = this.login + "#" + this.pass + "::" + nonce + "#" + endpoint;
        
        try{
            MessageDigest md = MessageDigest.getInstance("SHA-256");
            byte[] buffer = digestBase.getBytes("UTF-8");
            md.update(buffer);
            byte[] digest = md.digest();
            return AuthHandler.encodeHex(digest);
        } catch (NoSuchAlgorithmException | UnsupportedEncodingException ex) {
            Logger.getLogger(AuthHandler.class.getName()).log(Level.SEVERE, null, ex);
            return null;
        }        
    }
    
    private static String encodeHex(byte[] digest){
        StringBuilder sb = new StringBuilder();
        for(int i = 0; i< digest.length; i++){
            sb.append(Integer.toString((digest[i]&0xff)+0x100,16).substring(1));
        }
        return sb.toString();
    }
}
