/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exchange.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import config.Config;

import java.time.Instant;

/**
 *
 * @author janzubr
 */
@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME)
@JsonSubTypes({
    @JsonSubTypes.Type(value = InterfaceStateMessage.class, name = "InterfaceStateMessage"),
    @JsonSubTypes.Type(value = InterfaceConfigMessage.class, name = "InterfaceConfigMessage"),
    @JsonSubTypes.Type(value = BoardConfigMessage.class, name = "BoardConfigMessage"),
    @JsonSubTypes.Type(value = HeartbeatMessage.class, name = "HeartbeatMessage")
})
public abstract class ExchangeMessage {
    protected String nodeLogin;
    protected Instant timestamp;

    public ExchangeMessage() {
        this.timestamp = Instant.now();
        this.nodeLogin = Config.getLogin();
    }

    public Instant getTimestamp() {
        return timestamp;
    }

    public String getNodeLogin() {
        return nodeLogin;
    }

    public void setTimestamp(Instant timestamp) {
        this.timestamp = timestamp;
    }

    @Override
    public String toString() {
        return "ExchangeMessage{" +
                "timestamp=" + timestamp +
                '}';
    }
}
