package exchange.dto;

import board.io.Interface;
import board.io.InterfaceDirection;
import com.fasterxml.jackson.annotation.JsonIgnore;
import sun.reflect.generics.reflectiveObjects.NotImplementedException;

import java.util.*;
import java.util.stream.Collectors;

public class InterfaceStateMessage extends ExchangeMessage {
    private Map<String,List<Integer>> interfacesStates;

    public InterfaceStateMessage() {
        super();
    }

    public Map<String, List<Integer>> getInterfacesStates() {
        return interfacesStates;
    }

    public void setInterfacesStates(Map<String, List<Integer>> interfacesStates) {
        this.interfacesStates = interfacesStates;
    }

    @JsonIgnore
    public void setInterfacesStates(List<Interface> interfaces, InterfaceDirection dir){
        Map<String, List<Integer>> interfacesStates = new HashMap<>();
        for(Interface intf:interfaces){
            int[] data;
            if(dir==InterfaceDirection.IN){
                data = intf.getDataIn();
            }
            else if(dir==InterfaceDirection.OUT){
                data = intf.getDataOut();
            }
            else{
                throw new NotImplementedException();
            }

            List<Integer> dataList = Arrays.stream(data).boxed().collect(Collectors.toList());

            interfacesStates.put(intf.getDescriptor().getUid(),dataList);
        }
        this.setInterfacesStates(interfacesStates);
    }
}
