package support;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.fasterxml.jackson.datatype.jsr310.JavaTimeModule;
import exchange.dto.BoardConfigMessage;
import exchange.dto.ExchangeMessage;

import java.io.IOException;
import java.time.Instant;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author janzubr
 */
public class ResourceCache {
    private final ObjectMapper OM;
    
    private ResourceCache() {
        long startTime = Instant.now().toEpochMilli();
        this.OM = new ObjectMapper();
        this.OM.registerModule(new JavaTimeModule());
        this.OM.configure(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS, false);

        try{
            String messageJson = OM.writeValueAsString(new BoardConfigMessage());
            ExchangeMessage msgBack = OM.readValue(messageJson, new TypeReference<ExchangeMessage>(){});
        } catch (IOException e) {
            e.printStackTrace();
        }


        System.out.println("Resource cache initialized in : "+(Instant.now().toEpochMilli()-startTime)+"ms");
    }

    public ObjectMapper getObjectMapper() {
        return OM;
    }
    
    public static ResourceCache getInstance() {
        return ResourceCacheHolder.INSTANCE;
    }
    
    private static class ResourceCacheHolder {

        private static final ResourceCache INSTANCE = new ResourceCache();
    }
}
